/**
 * Exemple de code pour un servomoteur, il fait faire des va-et-vient à la tête du servomoteur.
 */

 /* Inclut la lib Servo pour manipuler le servomoteur */
#include <Servo.h>
#include <U8g2lib.h>
#include <U8x8lib.h>
#include <Arduino.h>
#include <SPI.h>
#include <Wire.h>
#include <math.h>

/* Créer un objet Servo pour contrôler le servomoteur */
Servo monServomoteur;
int potpin = 0;
int potpositif = 8;
int potnegatif = 9;

double val,correction;
double BC, AB, AC, TanB, angleB, angleC;
char affB[10],affDist[10],affC[10];

U8G2_SSD1306_128X32_UNIVISION_F_HW_I2C u8g2(U8G2_R0); 

void setup() {
  Serial.begin(115200);
  
   u8g2.begin();
   Wire.begin();
   u8g2.enableUTF8Print();  
     
  pinMode(potpin,INPUT);
  pinMode(potpositif,OUTPUT); 
  pinMode(potnegatif,OUTPUT); 

  // Attache le servomoteur à la broche D9
  monServomoteur.attach(3);
  digitalWrite(potnegatif,LOW);
  digitalWrite(potpositif,HIGH);

}

void loop() {

  for (int i=0; i<10001; i++){
    val = val + analogRead(potpin);
  }

  val = val / 10000;
  
  val = analogRead(potpin);
  //val= map(val, 0, 4064, 0.00, 90.00);  Bad resolution
  val = (val * 90) / 4064; // For better resolution
  monServomoteur.write(val); 
  //monServomoteur.write(0); For init
  
  angleC = 90 - val;

  //correction = map(val, 85, 0, 2.1, 1.9);
  angleB = 180 - 90 - angleC;
  TanB = tan(radians(angleB)); // Angle en degré

  AC = 14;
  AB = AC / TanB;
  
  dtostrf(angleB, 7, 2, affB);
  dtostrf(AB, 7, 1, affDist);  // Convert to char
  dtostrf(angleC, 7, 2, affC);

  /*Serial.print("Angle C: ");
  Serial.println(val);
  Serial.print("Angle B :");
  Serial.println(angleB);
  Serial.print("AC: ");
  Serial.println(AC);
  Serial.print("AB: ");
  Serial.println(AB);
  Serial.print("Tan B: ");
  Serial.println(TanB);*/

   u8g2.clearBuffer();          // clear the internal memory
   u8g2.setFont(u8g2_font_BitTypeWriter_tr);  // choose a suitable font at https://github.com/olikraus/u8g2/wiki/fntlistall
   u8g2.drawStr(5,8, "Distance : ");
   u8g2.drawStr(5,17, "Angle B :");
   u8g2.drawStr(5,26, "Angle C :");
   u8g2.drawStr(80,8, affDist);
   u8g2.drawStr(80,17, affB);
   u8g2.drawStr(80,26, affC);
   u8g2.sendBuffer(); 
  delay(200);

}
